local ArcanumGuildHall = _G['ArcanumGuildHall']

local function isDst()
    return os.date("*t").isdst
end

local function getDstOffset()
    return isDst() and 1 or 0
end

local function getUtc()
    local utcDate = os.date("!*t")
    utcDate.isdst = isDst()
    return os.time(utcDate)
end

function ArcanumGuildHall:GetTimezone()
    return tonumber(os.date("%z")) / 100 - getDstOffset()
end

function ArcanumGuildHall:GetTimeOffset()
    return ((self.db.clockDst and getDstOffset() or 0) + self.db.clockTimezone) * 3600
end

function ArcanumGuildHall:GetTimeString()
    return os.date("%H:%M", getUtc() + self:GetTimeOffset())
end

ArcanumGuildHall.defaults.clockTimezone = ArcanumGuildHall:GetTimezone()